/*
 *This library is free software; you can redistribute it and/or
 *modify it under the terms of the GNU Lesser General Public
 *License as published by the Free Software Foundation; either
 *version 2.1 of the License, or (at your option) any later version.
 *
 *This library is distributed in the hope that it will be useful,
 *but WITHOUT ANY WARRANTY; without even the implied warranty of
 *MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *Lesser General Public License for more details.
 *
 *You should have received a copy of the GNU Lesser General Public
 *License along with this library; if not, write to the Free Software
 *Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

/* 
 * This software was written by Phillip Lord (p.lord@hgmp.mrc.ac.uk)
 * whilst at the University of Manchester as a Pfizer post-doctoral 
 * Research Fellow. 
 *
 * The initial code base is copyright by Pfizer, or the University
 * of Manchester. Modifications to the initial code base are copyright
 * of their respective authors, or their employers as appropriate. 
 * Authorship of the modifications may be determined from the ChangeLog
 * placed at the end of this file
 */

package uk.ac.man.bioinf.sequence.complex; // Package name inserted by JPack

import uk.ac.man.bioinf.sequence.Residue;
import java.util.Arrays;
import uk.ac.man.bioinf.sequence.types.AbstractSequenceType;

/**
 * AbstractComplexSequenceType.java
 *
 *
 * Created: Tue Feb 29 22:10:30 2000
 *
 * @author Phillip Lord
 * @version $Id: AbstractComplexSequenceType.java,v 1.3 2001/04/11 17:04:43 lord Exp $
 */

public abstract class AbstractComplexSequenceType extends AbstractSequenceType
  implements ComplexSequenceType
{
  private Modification[] modifications;
  
  public AbstractComplexSequenceType( Residue[] residues, Modification modification, String name )
  {
    super( residues, name );
    modifications = new Modification[ 1 ];
    modifications[ 0 ] = modification;
  }
  
  public AbstractComplexSequenceType( Residue[] residues, Modification[] modifications, String name )
  {
    super( residues, name );
    this.modifications = modifications;
    // sort these to speed things up for boolean is methods
    Arrays.sort( modifications );
  }
  
  public Modification[] getModifications()
  {
    Modification[] retn = new Modification[ modifications.length ];
    System.arraycopy( modifications, 0, retn, 0, modifications.length );
    return retn;
  }
  
  public boolean isModification( Modification mod )
  {
    return (Arrays.binarySearch( modifications, mod ) > 0);
  }
  
  public boolean isModification( Modification[] mod )
  {
    for( int i = 0 ; i < mod.length ; i++ ){
      // iterate through and balk as soon as false
      if( isModification( mod[ i ] ) ){
	return false;
      }
    } //end for( i < modifications.length )
    return true;
  }
  
  public boolean isAllowableElement( ComplexElement elem )
  {
    // if this Residue isnt allowable then neither is the elem.
    if( !( isElement( elem.getResidue() ) ) ){
      return false;
    }
    
    // if the elem is allowable are all of its modifications?
    return isModification( elem.getModifications() );
  }
} // AbstractComplexSequenceType



/*
 * ChangeLog
 * $Log: AbstractComplexSequenceType.java,v $
 * Revision 1.3  2001/04/11 17:04:43  lord
 * Added License agreements to all code
 *
 * Revision 1.2  2000/04/18 17:51:48  jns
 * o changes madde because of files moved to types package.
 *
 * Revision 1.1  2000/03/01 14:33:07  lord
 * Initial checkin
 *
 */
